<?php
namespace Planejamento\Entities;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

class Cardacli extends Base\Cardacli
{
    
    public function insereCardacli($nrorg, $filial, $nrcardapio, $cliente, $destinos, $comensais, $cdoperador, $dtAtual){        
        $this->setNrorg($nrorg);
        $this->setCdfilial($filial);
        $this->setNrcardapio($nrcardapio);
        $this->setCdcliente($cliente);
        $this->setCddestfili($destinos);
        $this->setQtcomesticli($comensais);

        $this->setNrorginclusao($nrorg);
        $this->setCdoperinclusao($cdoperador);
        $this->setDtinclusao($dtAtual);
        $this->setDtultatu($dtAtual);

        $this->persist();
    }
    
    public function atualizaComensaisCli($nrorg, $comensais, $cdoperador, $dtAtual) {
        $this->setQtcomesticli($comensais);

        $this->setNrorgultatu($nrorg);
        $this->setCdoperultatu($cdoperador);
        $this->setDtultatu($dtAtual);
        
        $this->persist();
    }

    public static function atualizaComensais(
        $nrorg, $nrcardapio, $cdcliente, $cddestfili, $qtcomesticli
    )
    {
        try {
            $cardacli = Cardacli::getObjectByWhere(
                'NRORG = ? AND NRCARDAPIO = ? AND CDCLIENTE = ? AND CDDESTFILI = ?',
                array($nrorg, $nrcardapio, $cdcliente, $cddestfili)
            );

            if ($cardacli instanceof Cardacli) {
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();

                $cardacli->setQtcomesticli($qtcomesticli);
                $cardacli->setNrorgultatu($nrorg);
                $cardacli->setDtultatu(DateUtil::getDataAtual());
                $cardacli->setCdoperultatu(Ambiente::getCdoperador());
                $cardacli->persist();

                $connection->flush();
                $connection->commit();
            }

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function retornaComensais($nrorg, $cdfilial,$nrcardapio, $cdcliente, $cddestfili ){

        try {
            /**
             * @var \Planejamento\Entities\Cardacli $cardacli Cardacli
             */
                $cardacli = Cardacli::getObjectByWhere(
                'NRORG = ? AND CDFILIAL = ? AND NRCARDAPIO = ? AND CDCLIENTE = ? AND CDDESTFILI = ?',
                array($nrorg, $cdfilial, $nrcardapio, $cdcliente, $cddestfili)
            );
            if($cardacli){
                $qtcomesticli =$cardacli-> getQtcomesticli();
            }else{
                $qtcomesticli = 0;
            }

       }catch (\Exception $e){
            throw $e;
        }
        return $qtcomesticli;
    }
}